diff -uNr mythtv-0.21/libs/libmyth/lcddevice.cpp mythtv/libs/libmyth/lcddevice.cpp
--- mythtv-0.21/libs/libmyth/lcddevice.cpp	2007-12-11 15:56:01.000000000 +0100
+++ mythtv/libs/libmyth/lcddevice.cpp	2008-09-02 16:09:29.000000000 +0200
@@ -144,8 +144,10 @@
 
     if (res == 0)
     {
-        // we need to start the mythlcdserver 
+        // we need to start the mythlcdserver
+        VERBOSE(VB_GENERAL, "Starting mythlcdserver");
         system(gContext->GetInstallPrefix() + "/bin/mythlcdserver -v none&");
+        usleep(500000);
     }
 
     if (!bConnected)
@@ -153,7 +155,6 @@
         int count = 0;
         do
         {
-            usleep(500000);
             ++count;
 
             VERBOSE(VB_GENERAL, QString("Connecting to lcd server: " 
@@ -162,6 +163,7 @@
 
             if (socket)
                 socket->DownRef();
+
             socket = new MythSocket();
             socket->setCallbacks(this);
             socket->connect(hostname, port);
@@ -176,14 +178,22 @@
 
                 if (socket->state() == MythSocket::Connected)
                 {
-                    lcd_ready = true;
+                    lcd_ready = false;
                     bConnected = true;
 
                     QTextStream os(socket);
                     os << "HELLO\n";
+
+                    // HACK make sure the readyread_thread is awake
+                    usleep(1000);
+                    socket->Lock();
+                    socket->Unlock();
+
                     break;
                 }
             }
+
+            usleep(500000);
         }
         while (count < 10 && !bConnected);
     }
@@ -198,15 +208,12 @@
 {
     QMutexLocker locker(&socketLock);
 
-    if (!socket)
+    if (!socket || !lcd_ready)
         return;
 
     // Check the socket, make sure the connection is still up
     if (socket->state() == MythSocket::Idle)
     {
-        if (!lcd_ready)
-            return;
-
         lcd_ready = false;
 
         // Ack, connection to server has been severed try to re-establish the 
@@ -289,8 +296,6 @@
     if (aList[0] == "CONNECTED")
     {
         // We got "CONNECTED", which is a response to "HELLO"
-        lcd_ready = true;
-
         // get lcd width & height
         if (aList.count() != 3)
         {
@@ -362,7 +367,7 @@
     lcd_showrecstatus = (gContext->GetSetting("LCDShowRecStatus", "1") == "1");
     lcd_keystring = gContext->GetSetting("LCDKeyString", "ABCDEF");    
 
-    bConnected = TRUE;
+    bConnected = true;
     lcd_ready = true;
 
     // send buffer if there's anything in there
@@ -472,6 +477,9 @@
 
 void LCD::outputLEDs()
 {
+    if (!lcd_ready)
+        return;
+
     QString aString;
     int mask = 0;
     if (0 && GetLEDMask)
diff -uNr mythtv-0.21/libs/libmyth/libmyth.pro mythtv/libs/libmyth/libmyth.pro
--- mythtv-0.21/libs/libmyth/libmyth.pro	2008-03-04 18:08:41.000000000 +0100
+++ mythtv/libs/libmyth/libmyth.pro	2009-04-19 23:30:15.000000000 +0200
@@ -26,6 +26,7 @@
 HEADERS += volumebase.h volumecontrol.h virtualkeyboard.h visual.h xmlparse.h
 HEADERS += mythhdd.h mythcdrom.h storagegroup.h dbutil.h
 HEADERS += compat.h
+HEADERS += audiopulseutil.h
 
 SOURCES += audiooutput.cpp audiooutputbase.cpp audiooutputnull.cpp
 SOURCES += audiooutputdigitalencoder.cpp
@@ -42,6 +43,7 @@
 SOURCES += uilistbtntype.cpp uitypes.cpp util.cpp util-x11.cpp
 SOURCES += volumebase.cpp volumecontrol.cpp virtualkeyboard.cpp xmlparse.cpp
 SOURCES += mythhdd.cpp mythcdrom.cpp storagegroup.cpp dbutil.cpp
+SOURCES += audiopulseutil.cpp
 
 INCLUDEPATH += ../libmythsamplerate ../libmythsoundtouch ../libmythfreesurround
 INCLUDEPATH += ../libavcodec ../libavutil
@@ -83,12 +85,21 @@
 inc2.files = $${inc.files}
 
 
+DEFINES += RUNPREFIX=\"$${RUNPREFIX}\"
+DEFINES += LIBDIRNAME=\"$${LIBDIRNAME}\"
+
+
 using_oss {
     DEFINES += USING_OSS
     SOURCES += audiooutputoss.cpp
     HEADERS += audiooutputoss.h
 }
 
+using_pulse {
+    DEFINES += USING_PULSE
+    LIBS += $$PULSE_LIBS
+}
+
 unix:!cygwin {
     SOURCES += mediamonitor-unix.cpp
     HEADERS += mediamonitor-unix.h
@@ -107,9 +118,6 @@
 
     LIBS += -lpthread
 
-    # For easier debugging:
-    target.path = $${PREFIX}/bin
-
     LIBS -= -lmythui-$$LIBVERSION  -lmythupnp-$$LIBVERSION 
     LIBS += -L. -lmythui-bootstrap -lmythupnp-bootstrap
     POST_TARGETDEPS += libmythui-bootstrap.a libmythupnp-bootstrap.a
@@ -241,3 +249,5 @@
 contains( CONFIG_LIBFFTW3, yes ) {
     LIBS += -lfftw3f
 }
+
+include ( ../libs-targetfix.pro )
diff -uNr mythtv-0.21/libs/libmyth/mythcdrom.cpp mythtv/libs/libmyth/mythcdrom.cpp
--- mythtv-0.21/libs/libmyth/mythcdrom.cpp	2008-01-10 01:35:48.000000000 +0100
+++ mythtv/libs/libmyth/mythcdrom.cpp	2009-04-02 08:13:16.000000000 +0200
@@ -47,20 +47,6 @@
 {
 }
 
-bool MythCDROM::openDevice()
-{
-    if (MythMediaDevice::openDevice()) 
-    {
-        // If allow eject is on, unlock the door.
-        if (m_AllowEject)
-            unlock();
-        
-        return true;
-    }
-
-    return false;
-}
-
 void MythCDROM::onDeviceMounted()
 {
     if (!QDir(m_MountPath).exists())
@@ -119,7 +105,19 @@
     if (MEDIATYPE_DATA == m_MediaType)
         MythMediaDevice::onDeviceMounted();
 
+
+    // Unlock the door, and if appropriate unmount the media,
+    // so the user can press the manual eject button
     if (m_AllowEject)
+    {
         unlock();
+        if (m_MediaType == MEDIATYPE_DVD || m_MediaType == MEDIATYPE_VCD)
+            unmount();
+    }
 }
 
+void MythCDROM::setSpeed(const char *devicePath, int speed)
+{
+    VERBOSE(VB_MEDIA, QString("SetSpeed(%1,%2) - not implemented on this OS.")
+                      .arg(devicePath).arg(speed));
+}
diff -uNr mythtv-0.21/libs/libmyth/mythcdrom.h mythtv/libs/libmyth/mythcdrom.h
--- mythtv-0.21/libs/libmyth/mythcdrom.h	2006-10-08 01:01:31.000000000 +0200
+++ mythtv/libs/libmyth/mythcdrom.h	2009-04-02 08:13:16.000000000 +0200
@@ -14,11 +14,11 @@
 
     virtual bool mediaChanged(void) { return false; }
     virtual bool checkOK(void)      { return true; }
-    virtual bool openDevice(void);
     virtual MediaStatus checkMedia(void)
     {
         return setStatus(MEDIASTAT_UNKNOWN, false);
     }
+    virtual void setSpeed(const char *devicePath, int speed);
 
     static MythCDROM* get(QObject* par, const char* devicePath,
                                   bool SuperMount, bool AllowEject);
diff -uNr mythtv-0.21/libs/libmyth/mythcdrom-linux.cpp mythtv/libs/libmyth/mythcdrom-linux.cpp
--- mythtv-0.21/libs/libmyth/mythcdrom-linux.cpp	2008-01-17 11:46:04.000000000 +0100
+++ mythtv/libs/libmyth/mythcdrom-linux.cpp	2009-04-02 08:13:16.000000000 +0200
@@ -20,7 +20,7 @@
 #define ASSUME_WANT_AUDIO 1
 
 // This class is verbose enough, but if you really need more output:
-//#define EXTRA_VERBOSITY   1
+#define EXTRA_VERBOSITY   1
 
 
 // Some features cannot be detected (reliably) using the standard
@@ -133,6 +133,7 @@
     virtual MediaStatus checkMedia(void);
     virtual MediaError eject(bool open_close = true);
     virtual void setSpeed(int speed);
+    virtual void setSpeed(const char *device, int speed);
     virtual bool isSameDevice(const QString &path);
     virtual MediaError lock(void);
     virtual MediaError unlock(void);
@@ -162,7 +163,13 @@
 {
     int drive_status = ioctl(m_DeviceHandle, CDROM_DRIVE_STATUS, CDSL_CURRENT);
 
-    if (drive_status == CDS_TRAY_OPEN && getDevicePath().contains("/dev/scd"))
+    if (drive_status == -1)   // Very unlikely, but we should check
+    {
+        VERBOSE(VB_MEDIA, LOC + ":driveStatus() - ioctl() failed: " + ENO);
+        return CDS_NO_INFO;
+    }
+
+    if (drive_status == CDS_TRAY_OPEN && m_DevicePath.contains("/dev/scd"))
         return SCSIstatus();
 
     return drive_status;
@@ -193,7 +200,7 @@
         VERBOSE(VB_MEDIA,
                 LOC + ":hasWritableMedia() - failed to send packet to "
                     + m_DevicePath);
-        return 0;
+        return false;
     }
 
     di = (CDROMdiscInfo *) buffer;
@@ -327,7 +334,7 @@
         {
 #ifdef EXTRA_VERBOSITY
             VERBOSE(VB_MEDIA, LOC + ":testMedia - failed to open "
-                              + getDevicePath() + ENO);
+                              + m_DevicePath + ENO);
 #endif
             if (errno == EBUSY)
                 return isMounted(true) ? MEDIAERR_OK : MEDIAERR_FAILED;
@@ -350,8 +357,8 @@
 
     if (Stat == -1)
     {
-        VERBOSE(VB_MEDIA, LOC + ":testMedia - Failed to get drive status of "
-                          + getDevicePath() + ENO);
+        VERBOSE(VB_MEDIA, LOC + ":testMedia - Failed to get drive status of '"
+                          + m_DevicePath + "' : " + ENO);
         return MEDIAERR_FAILED;
     }
 
@@ -362,198 +369,182 @@
 {
     bool OpenedHere = false;
 
-    if (testMedia() != MEDIAERR_OK)
-    {
-        m_MediaType = MEDIATYPE_UNKNOWN;
-        return setStatus(MEDIASTAT_UNKNOWN, OpenedHere);
-    }
-
     // If it's not already open we need to at least
     // TRY to open it for most of these checks to work.
     if (!isDeviceOpen())
+    {
         OpenedHere = openDevice();
 
-    if (isDeviceOpen())
+        if (!OpenedHere)
+        {
+            VERBOSE(VB_MEDIA, LOC + ":checkMedia() - cannot open device '"
+                                  + m_DevicePath + "' : "
+                                  + ENO + "- returning UNKNOWN");
+            m_MediaType = MEDIATYPE_UNKNOWN;
+            return setStatus(MEDIASTAT_UNKNOWN, false);
+        }
+    }
+
+    switch (driveStatus())
+    {
+        case CDS_DISC_OK:
+            VERBOSE(VB_MEDIA, m_DevicePath + " Disk OK, type = "
+                              + MediaTypeString(m_MediaType) );
+            // further checking is required
+            break;
+        case CDS_TRAY_OPEN:
+            VERBOSE(VB_MEDIA, m_DevicePath + " Tray open or no disc");
+            // First, send a message to the
+            // plugins to forget the current media type
+            setStatus(MEDIASTAT_OPEN, OpenedHere);
+            // then reset
+            m_MediaType = MEDIATYPE_UNKNOWN;
+            return MEDIASTAT_OPEN;
+            break;
+        case CDS_NO_DISC:
+            VERBOSE(VB_MEDIA, m_DevicePath + " No disc");
+            m_MediaType = MEDIATYPE_UNKNOWN;
+            return setStatus(MEDIASTAT_NODISK, OpenedHere);
+            break;
+        case CDS_NO_INFO:
+        case CDS_DRIVE_NOT_READY:
+            VERBOSE(VB_MEDIA, m_DevicePath + " No info or drive not ready");
+            m_MediaType = MEDIATYPE_UNKNOWN;
+            return setStatus(MEDIASTAT_UNKNOWN, OpenedHere);
+        default:
+            VERBOSE(VB_IMPORTANT, "Failed to get drive status of "
+                                  + m_DevicePath + " : " + ENO);
+            m_MediaType = MEDIATYPE_UNKNOWN;
+            return setStatus(MEDIASTAT_UNKNOWN, OpenedHere);
+    }
+
+    if (mediaChanged())
+    {
+        VERBOSE(VB_MEDIA, m_DevicePath + " Media changed");
+        // Regardless of the actual status lie here and say
+        // it's open for now, so we can cover the case of a missed open.
+        return setStatus(MEDIASTAT_OPEN, OpenedHere);
+    }
+
+
+    if (isUsable())
+    {
+#ifdef EXTRA_VERBOSITY
+        VERBOSE(VB_MEDIA, "Disc useable, media unchanged. All good!");
+#endif
+        if (OpenedHere)
+            closeDevice();
+        return MEDIASTAT_USEABLE;
+    }
+
+    // If we have tried to mount and failed, don't keep trying
+    if (m_Status == MEDIASTAT_ERROR)
     {
 #ifdef EXTRA_VERBOSITY
-        VERBOSE(VB_MEDIA, LOC + ":checkMedia - Device is open...");
+        VERBOSE(VB_MEDIA, "Disc is unmountable?");
 #endif
-        switch (driveStatus())
+        if (OpenedHere)
+            closeDevice();
+        return m_Status;
+    }
+
+    if ((m_Status == MEDIASTAT_OPEN) ||
+        (m_Status == MEDIASTAT_UNKNOWN))
+    {
+        VERBOSE(VB_MEDIA, m_DevicePath + " Current status " +
+                MythMediaDevice::MediaStatusStrings[m_Status]);
+        int type = ioctl(m_DeviceHandle, CDROM_DISC_STATUS, CDSL_CURRENT);
+        switch (type)
         {
-            case CDS_DISC_OK:
-                VERBOSE(VB_MEDIA, getDevicePath() + " Disk OK, type = "
-                                  + MediaTypeString(m_MediaType) );
-                // 1. Audio CDs are not mounted
-                // 2. If we don't know the media type yet,
-                //    test the disk after this switch exits
-                if (m_MediaType == MEDIATYPE_AUDIO ||
-                    m_MediaType == MEDIATYPE_UNKNOWN)
-                    break;
-                // If we have tried to mount and failed, don't keep trying:
-                if (m_Status == MEDIASTAT_ERROR)
-                    return m_Status;
-                // If the disc is ok and we already know it's mediatype
-                // returns MOUNTED.
+            case CDS_DATA_1:
+            case CDS_DATA_2:
+                m_MediaType = MEDIATYPE_DATA;
+                VERBOSE(VB_MEDIA, "Found a data disk");
+                //grab information from iso9660 (& udf)
+                struct iso_primary_descriptor buf;
+                lseek(this->m_DeviceHandle,(off_t) 2048*16,SEEK_SET);
+                read(this->m_DeviceHandle, &buf,2048);
+                this->m_VolumeID = QString(buf.volume_id).stripWhiteSpace();
+                this->m_KeyID = QString("%1%2").arg(this->m_VolumeID)
+                                .arg(QString(buf.creation_date).left(16));
+
+                // the base class's onDeviceMounted will do fine
+                // grained detection of the type of data on this disc
                 if (isMounted(true))
+                    onDeviceMounted();
+                else
+                    if (mount())
+                        ;    // onDeviceMounted() called as side-effect
+                    else
+                        return setStatus(MEDIASTAT_ERROR, OpenedHere);
+
+                if (isMounted(true))
+                {
+                    // pretend we're NOTMOUNTED so setStatus emits a signal
+                    m_Status = MEDIASTAT_NOTMOUNTED;
                     return setStatus(MEDIASTAT_MOUNTED, OpenedHere);
+                }
+                else if (m_MediaType == MEDIATYPE_DVD)
+                {
+                    // pretend we're NOTMOUNTED so setStatus emits a signal
+                    m_Status = MEDIASTAT_NOTMOUNTED;
+                    return setStatus(MEDIASTAT_USEABLE, OpenedHere);
+                }
+                else
+                    return setStatus(MEDIASTAT_NOTMOUNTED, OpenedHere);
                 break;
-            case CDS_TRAY_OPEN:
-                VERBOSE(VB_MEDIA, getDevicePath() + " Tray open or no disc");
-                setStatus(MEDIASTAT_OPEN, OpenedHere);
-                m_MediaType = MEDIATYPE_UNKNOWN;
-                return MEDIASTAT_OPEN;
+            case CDS_AUDIO:
+                VERBOSE(VB_MEDIA, "found an audio disk");
+                m_MediaType = MEDIATYPE_AUDIO;
+                return setStatus(MEDIASTAT_USEABLE, OpenedHere);
                 break;
-            case CDS_NO_DISC:
-                VERBOSE(VB_MEDIA, getDevicePath() + " No disc");
-                m_MediaType = MEDIATYPE_UNKNOWN;
-                return setStatus(MEDIASTAT_NODISK, OpenedHere);
+            case CDS_MIXED:
+                m_MediaType = MEDIATYPE_MIXED;
+                VERBOSE(VB_MEDIA, "found a mixed CD");
+                // Note: Mixed mode CDs require an explixit mount call
+                //       since we'll usually want the audio portion.
+                // undefine ASSUME_WANT_AUDIO to change this behavior.
+                #ifdef ASSUME_WANT_AUDIO
+                    return setStatus(MEDIASTAT_USEABLE, OpenedHere);
+                #else
+                    mount();
+                    if (isMounted(true))
+                    {
+                        // pretend we're NOTMOUNTED so setStatus
+                        // emits a signal
+                        m_Status = MEDIASTAT_NOTMOUNTED;
+                        return setStatus(MEDIASTAT_MOUNTED, OpenedHere);
+                    }
+                    else
+                    {
+                        return setStatus(MEDIASTAT_USEABLE, OpenedHere);
+                    }
+                #endif
                 break;
             case CDS_NO_INFO:
-            case CDS_DRIVE_NOT_READY:
-                VERBOSE(VB_MEDIA, getDevicePath()
-                                  + " No info or drive not ready");
+            case CDS_NO_DISC:
+                if (hasWritableMedia())
+                {
+                    VERBOSE(VB_MEDIA, "found a blank or writable disk");
+                    return setStatus(MEDIASTAT_UNFORMATTED, OpenedHere);
+                }
+
+                VERBOSE(VB_MEDIA, "found no disk");
                 m_MediaType = MEDIATYPE_UNKNOWN;
                 return setStatus(MEDIASTAT_UNKNOWN, OpenedHere);
+                break;
             default:
-                VERBOSE(VB_IMPORTANT, "Failed to get drive status of "
-                                      + getDevicePath() + " : " + ENO);
+                VERBOSE(VB_MEDIA, "found unknown disk type: "
+                                  + QString().setNum(type));
                 m_MediaType = MEDIATYPE_UNKNOWN;
                 return setStatus(MEDIASTAT_UNKNOWN, OpenedHere);
         }
+    }
 
-        if (mediaChanged())
-        {
-            VERBOSE(VB_MEDIA, getDevicePath() + " Media changed");
-            // Regardless of the actual status lie here and say
-            // it's open for now, so we can cover the case of a missed open.
-            return setStatus(MEDIASTAT_OPEN, OpenedHere);
-        }
-        else
-        {
-#ifdef EXTRA_VERBOSITY
-            VERBOSE(VB_MEDIA, getDevicePath() + " Media unchanged...");
-#endif
-            if ((m_Status == MEDIASTAT_OPEN) ||
-                (m_Status == MEDIASTAT_UNKNOWN))
-            {
-                VERBOSE(VB_MEDIA, getDevicePath() + " Current status " +
-                        MythMediaDevice::MediaStatusStrings[m_Status]);
-                int type = ioctl(m_DeviceHandle,
-                                 CDROM_DISC_STATUS, CDSL_CURRENT);
-                switch (type)
-                {
-                    case CDS_DATA_1:
-                    case CDS_DATA_2:
-                        m_MediaType = MEDIATYPE_DATA;
-                        VERBOSE(VB_MEDIA, "Found a data disk");
-                        //grab information from iso9660 (& udf)
-                        struct iso_primary_descriptor buf;
-                        lseek(this->m_DeviceHandle,(off_t) 2048*16,SEEK_SET);
-                        read(this->m_DeviceHandle, &buf,2048);
-                        this->m_VolumeID = QString(buf.volume_id)
-                                                       .stripWhiteSpace();
-                        this->m_KeyID = QString("%1%2")
-                                      .arg(this->m_VolumeID)
-                                      .arg(QString(buf.creation_date).left(16));
-
-                        // the base class's onDeviceMounted will do fine
-                        // grained detection of the type of data on this disc
-                        if (isMounted(true))
-                            onDeviceMounted();
-                        else
-                            if (mount())
-                                ;    // onDeviceMounted() called as side-effect
-                            else
-                                return setStatus(MEDIASTAT_ERROR, OpenedHere);
-
-                        if (isMounted(true))
-                        {
-                            // pretend we're NOTMOUNTED so setStatus emits
-                            // a signal
-                            m_Status = MEDIASTAT_NOTMOUNTED;
-                            return setStatus(MEDIASTAT_MOUNTED, OpenedHere);
-                        }
-                        else if (m_MediaType == MEDIATYPE_DVD)
-                        {
-                            // pretend we're NOTMOUNTED so setStatus emits
-                            // a signal
-                            m_Status = MEDIASTAT_NOTMOUNTED;
-                            return setStatus(MEDIASTAT_USEABLE, OpenedHere);
-                        }
-                        else
-                            return setStatus(MEDIASTAT_NOTMOUNTED, OpenedHere);
-                        break;
-                    case CDS_AUDIO:
-                        VERBOSE(VB_MEDIA, "found an audio disk");
-                        m_MediaType = MEDIATYPE_AUDIO;
-                        return setStatus(MEDIASTAT_USEABLE, OpenedHere);
-                        break;
-                    case CDS_MIXED:
-                        m_MediaType = MEDIATYPE_MIXED;
-                        VERBOSE(VB_MEDIA, "found a mixed CD");
-                        // Note: Mixed mode CDs require an explixit mount call
-                        //       since we'll usually want the audio portion.
-                        // undefine ASSUME_WANT_AUDIO to change this behavior.
-                        #ifdef ASSUME_WANT_AUDIO
-                            return setStatus(MEDIASTAT_USEABLE, OpenedHere);
-                        #else
-                            mount();
-                            if (isMounted(true))
-                            {
-                                // pretend we're NOTMOUNTED so setStatus
-                                // emits a signal
-                                m_Status = MEDIASTAT_NOTMOUNTED;
-                                return setStatus(MEDIASTAT_MOUNTED,
-                                                 OpenedHere);
-                            }
-                            else
-                            {
-                                return setStatus(MEDIASTAT_USEABLE,
-                                                 OpenedHere);
-                            }
-                        #endif
-                        break;
-                    case CDS_NO_INFO:
-                    case CDS_NO_DISC:
-                        if (hasWritableMedia())
-                        {
-                            VERBOSE(VB_MEDIA, "found a blank or writable disk");
-                            return setStatus(MEDIASTAT_UNFORMATTED, OpenedHere);
-                        }
-
-                        VERBOSE(VB_MEDIA, "found no disk");
-                        m_MediaType = MEDIATYPE_UNKNOWN;
-                        return setStatus(MEDIASTAT_UNKNOWN, OpenedHere);
-                        break;
-                    default:
-                        VERBOSE(VB_MEDIA, "found unknown disk type: "
-                                          + QString().setNum(type));
-                        m_MediaType = MEDIATYPE_UNKNOWN;
-                        return setStatus(MEDIASTAT_UNKNOWN, OpenedHere);
-                }
-            }
-            else if (m_Status == MEDIASTAT_MOUNTED ||
-                     m_Status == MEDIASTAT_NOTMOUNTED)
-            {
-                VERBOSE(VB_MEDIA, QString("Current status == ") +
-                        MythMediaDevice::MediaStatusStrings[m_Status]);
-                VERBOSE(VB_MEDIA, "Setting status to not mounted?");
-                if (isMounted(true))
-                    setStatus(MEDIASTAT_MOUNTED, OpenedHere);
-                else
-                    setStatus(MEDIASTAT_NOTMOUNTED, OpenedHere);
-            }
-
-            if (m_AllowEject)
-                ioctl(m_DeviceHandle, CDROM_LOCKDOOR, 0);
-        }// mediaChanged()
-    } // isDeviceOpen();
+    if (m_AllowEject)
+        unlock();
     else
-    {
-        VERBOSE(VB_MEDIA, "Device not open - returning UNKNOWN");
-        m_MediaType = MEDIATYPE_UNKNOWN;
-        return setStatus(MEDIASTAT_UNKNOWN, OpenedHere);
-    }
+        lock();
 
     if (OpenedHere)
         closeDevice();
@@ -623,6 +614,11 @@
  */
 void MythCDROMLinux::setSpeed(int speed)
 {
+    MythCDROMLinux::setSpeed(m_DevicePath, speed);
+}
+
+void MythCDROMLinux::setSpeed(const char *device, int speed)
+{
     int fd;
     unsigned char buffer[28];
     unsigned char cmd[16];
@@ -637,11 +633,11 @@
     memset(cmd, 0, sizeof(cmd));
     memset(&st, 0, sizeof(st));
 
-    if (stat(m_DevicePath, &st) == -1)
+    if (stat(device, &st) == -1)
     {
         VERBOSE(VB_MEDIA, LOC_ERR +
                 QString("setSpeed() Failed. device %1 not found")
-                .arg(m_DevicePath));
+                .arg(device));
         return;
     }
 
@@ -651,7 +647,7 @@
         return;
     }
 
-    if ((fd = open(m_DevicePath, O_RDWR | O_NONBLOCK)) == -1)
+    if ((fd = open(device, O_RDWR | O_NONBLOCK)) == -1)
     {
         VERBOSE(VB_MEDIA, LOC_ERR + "Changing CD/DVD speed needs write access");
         return;
@@ -712,17 +708,22 @@
     buffer[18] = buffer[26] = 0x03;
     buffer[19] = buffer[27] = 0xe8;
 
-    // On my system (2.6.18 + ide-cd),  SG_IO succeeds without doing anything,
-    // while CDROM_SELECT_SPEED works...
-    if (ioctl(fd, CDROM_SELECT_SPEED, speed) < 0)
+    if (ioctl(fd, SG_IO, &sghdr) < 0)
     {
-        if (ioctl(fd, SG_IO, &sghdr) < 0)
-            VERBOSE(VB_MEDIA, LOC_ERR + "Limit CD/DVD Speed Failed");
+        VERBOSE(VB_MEDIA, LOC_ERR + "Limit CD/DVD Speed Failed");
     }
     else
+    {
+        // On my system (2.6.18 + ide-cd),  SG_IO succeeds without doing anything,
+        // while CDROM_SELECT_SPEED works...
+        if (ioctl(fd, CDROM_SELECT_SPEED, speed) < 0)
+        {
+            VERBOSE(VB_MEDIA, LOC_ERR +
+                    "Limit CD/DVD CDROM_SELECT_SPEED Failed");
+        }
         VERBOSE(VB_MEDIA, LOC + ":setSpeed() - CD/DVD Speed Set Successful");
+    }
 
     close(fd);
 }
 #endif
-
